image: gradle:alpine

stages:
  - build
  - test
  - pages
  - deploy

variables:
  GRADLE_OPTS: "-Dorg.gradle.daemon=false"

before_script:
  - export GRADLE_USER_HOME=`pwd`/.gradle


build:
  stage: build
  script:
   - mv build-ci.gradle build.gradle
   - export VERSION=SNAPSHOT 
   - gradle --build-cache assemble
  artifacts:
    paths:
      - build/libs/*.jar
    expire_in: 1 week
    
test:
  stage: test
  script:
   - mv build-ci.gradle build.gradle
   - export VERSION=SNAPSHOT
   - gradle check
  artifacts:
    paths:
     - build/reports/
     - config/html/
 
javadoc:
  stage: test
  script:
    - mv build-ci.gradle build.gradle
    - export VERSION=SNAPSHOT
    - gradle javadoc
  artifacts:
    paths:
     - build/docs/

 
pages:
  stage: pages
  script:
    - mv build-ci.gradle build.gradle
    - export VERSION=SNAPSHOT
    - mkdir public
    - mv config/html/* public
    - mv build/reports/* public
    - mv build/docs/* public
    - mv build/libs/*.jar public
    - cat public/jacoco/index.html
  artifacts:
    paths:
      - public
    expire_in: 1 day

upload:
  stage: deploy
  script:
   - mv build-ci.gradle build.gradle
   - export VERSION=${CI_COMMIT_TAG}
   - gradle upload
  only:
   - tags
  except:
   - branches 
  
after_script:
  - echo "End CI"
